$regfile = "m328pdef.dat"
$crystal = 16000000
$hwstack = 128
$swstack = 64
$framesize = 128

Dim I1 As Byte , I2 As Byte , I3 As Byte
Dim Za_pcf8574 As Byte , Iz_pcf8574 As Byte
Dim Kbd_col1 As Byte , Kbd_col2 As Byte , Kbd_col3 As Byte
Dim Tipka As Byte
Dim Sifra As String * 4
Dim Nevidljiva_sifra As String * 4
Dim Sifra_0 As Byte , Sifra_0e As Eram Byte
Dim Sifra_1 As String * 4 , Sifra_1e As Eram String * 4
Dim Sifra_2 As String * 4 , Sifra_2e As Eram String * 4
Dim Sifra_rst As String * 4 , Sifra_kfg As String * 4
Dim Step_data As Byte , Step_n As Word
Dim Step_i1 As Byte , Step_i2 As Byte , Step_korak As Byte
Dim Nacin_rada As Byte
Dim Sifra_poruka As String * 16
Dim Smjer_1 As Byte , Smjer_2 As Byte

Config Clockdiv = 1

Sifra_rst = "0000"                 'reset
Sifra_kfg = "9999"                 'konfiguracija

Hc595out Alias Portd.7
Hc595clk Alias Portb.0
Hc595ltc Alias Portb.4

Const Step_delay = 2
Const Pcf8574_adresa = &B01001100

Const Lcd_i2c_mode = 1             '1 = I2C LCD, 0 = paralelni LCD
Const Rgb = "K"                    'A = z. anoda, K = z. katoda
Nacin_rada = 0                     '0 = normalni nain, 1 i 2 = konfiguracija

Rgb_r Alias Portd.3
Rgb_g Alias Portd.5
Rgb_b Alias Portd.6
Rgb_1 Alias Portd.4
Rgb_2 Alias Portd.2

Config Rgb_r = Output
Config Rgb_g = Output
Config Rgb_b = Output
Config Rgb_1 = Output
Config Rgb_2 = Output

Beep_pin Alias Portb.3
Config Beep_pin = Output
Beep_pin = 0

Rst_pin Alias Pinb.5
Config Rst_pin = Input
Portb.5 = 1

Hc595clk = 0
Hc595ltc = 0

'Config Hc595out = Output
'Config Hc595clk = Output
Config Hc595ltc = Output

$lib "i2c_twi.lbx"
Config Twi = 100000                'brzina komunikacije = 100kHz

Config Sda = Portc.4
Config Scl = Portc.5
I2cinit

Config Lcd = 16 * 2
Config Lcdbus = 4
Config Lcdpin = Pin , Db7 = Portc.3 , Db6 = Portc.2 , Db5 = Portc.1 , Db4 = Portc.0 , E = Portc.4 , Rs = Portc.5
#if Lcd_i2c_mode = 1
$include "I2CLCD.sub"
Lcd$init &B0111                    '0=PCF8574, 111=A2-A0
#endif
Cursor Off
Cls

Deflcdchar 1 , 10 , 4 , 14 , 16 , 16 , 17 , 14 , 32       '
Cls
'Deflcdchar x , 2 , 4 , 14 , 16 , 16 , 17 , 14 , 32          '
'Deflcdchar x , 1 , 3 , 1 , 15 , 17 , 17 , 15 , 32       '
Deflcdchar 2 , 10 , 4 , 14 , 16 , 14 , 1 , 30 , 32       '
Cls
'Deflcdchar x , 10 , 4 , 31 , 2 , 4 , 8 , 31 , 32            '

#if Rgb = "A"
Macro Rgb_1_off
  Rgb_1 = 0
End Macro
Macro Rgb_2_off
  Rgb_2 = 0
End Macro
Macro Rgb_1_on
  Rgb_1 = 1
End Macro
Macro Rgb_2_on
  Rgb_2 = 1
End Macro
Macro Rgb_r_off
  Rgb_r = 1
End Macro
Macro Rgb_g_off
  Rgb_g = 1
End Macro
Macro Rgb_b_off
  Rgb_b = 1
End Macro
Macro Rgb_r_on
  Rgb_r = 0
End Macro
Macro Rgb_g_on
  Rgb_g = 0
End Macro
Macro Rgb_b_on
  Rgb_b = 0
End Macro
#endif

#if Rgb = "K"
Macro Rgb_1_on
  Rgb_1 = 0
End Macro
Macro Rgb_2_on
  Rgb_2 = 0
End Macro
Macro Rgb_1_off
  Rgb_1 = 1
End Macro
Macro Rgb_2_off
  Rgb_2 = 1
End Macro
Macro Rgb_r_on
  Rgb_r = 1
End Macro
Macro Rgb_g_on
  Rgb_g = 1
End Macro
Macro Rgb_b_on
  Rgb_b = 1
End Macro
Macro Rgb_r_off
  Rgb_r = 0
End Macro
Macro Rgb_g_off
  Rgb_g = 0
End Macro
Macro Rgb_b_off
  Rgb_b = 0
End Macro
#endif

Rgb_r_off
Rgb_g_off
Rgb_b_off
Rgb_1_on
Rgb_2_off

Lcd "   STEM  2023   "
Home L

Lcd "Sef pripravljen!"
Sifra_poruka = "Vpi{002}i kodo!     "
Lcd$bl_on

Step_i1 = 1 : Gosub Step1_1_korak
Step_i2 = 1 : Gosub Step2_1_korak
Gosub Step12_iskljuci

Rgb_1_on
Rgb_r_on
Waitms 500
Rgb_g_on
Waitms 500
Rgb_r_off
Waitms 500
Rgb_b_on
Waitms 500
Rgb_g_off
Waitms 500
Rgb_r_on
Waitms 500
Rgb_b_off
Rgb_r_off
Cls
Waitms 500

Sifra_0 = Sifra_0e
If Sifra_0 = 12 Then
  Sifra_1 = Sifra_1e               '1. vrata
  Sifra_2 = Sifra_2e               '2. vrata
Else
  Home L
  Gosub Reset_sifri
  Gosub Ugadjanje_vrata
End If

'P1=C1 P2=C2 P3=C3
'P4=R1 P5=R2 P6=R3 P7=R4

Gosub Brisi_sifru

Gosub Beep

Do
  Gosub Debounce_kbd1
  Gosub Provjeri_tipku
  Gosub Debounce_kbd2
  Gosub Provjeri_tipku
  Gosub Debounce_kbd3
  Gosub Provjeri_tipku
'  Waitms 10
  If I3 < 100 Then
    Incr I3
  Else
    Gosub Ucini_sifru_nevidljivom
  End If
Loop

End

Debounce_kbd1:
  Za_pcf8574 = &B11111101
  Gosub Pcf8574_pisi_citaj
  If Kbd_col1 <> Iz_pcf8574 Then
    Kbd_col1 = Iz_pcf8574
    Select Case Kbd_col1
    Case &B11100000 : Tipka = "1"
    Case &B11010000 : Tipka = "4"
    Case &B10110000 : Tipka = "7"
    Case &B01110000 : Tipka = "C"
    Case &B11110000 : Tipka = "_"
    Case Else : Tipka = "?"
    End Select
  End If
Return

Debounce_kbd2:
  Za_pcf8574 = &B11111011
  Gosub Pcf8574_pisi_citaj
  If Kbd_col2 <> Iz_pcf8574 Then
    Kbd_col2 = Iz_pcf8574
    Select Case Kbd_col2
    Case &B11100000 : Tipka = "2"
    Case &B11010000 : Tipka = "5"
    Case &B10110000 : Tipka = "8"
    Case &B01110000 : Tipka = "0"
    Case &B11110000 : Tipka = "_"
    Case Else : Tipka = "?"
    End Select
  End If
Return

Debounce_kbd3:
  Za_pcf8574 = &B11110111
  Gosub Pcf8574_pisi_citaj
  If Kbd_col3 <> Iz_pcf8574 Then
    Kbd_col3 = Iz_pcf8574
    Select Case Kbd_col3
    Case &B11100000 : Tipka = "3"
    Case &B11010000 : Tipka = "6"
    Case &B10110000 : Tipka = "9"
    Case &B01110000 : Tipka = "O"
    Case &B11110000 : Tipka = "_"
    Case Else : Tipka = "?"
    End Select
  End If
Return

Provjeri_tipku:
  Select Case Tipka
  Case "0" To "9":
    Gosub Beep
    Gosub Ucini_sifru_nevidljivom
    If I2 >= 4 Then
      Gosub Brisi_sifru
    End If
    Incr I2
    Mid(sifra , I2 , 1) = Tipka
    Mid(nevidljiva_sifra , I2 , 1) = Tipka
    Gosub Disp_sifre
    I3 = 0
  Case "C":
    Gosub Beep
    Gosub Brisi_sifru
  Case "O":
    Gosub Beep
    Gosub Provjeri_sifru
    Gosub Brisi_sifru
  Case "?":
    Gosub Beep_3
    Gosub Brisi_sifru
  End Select
  Tipka = "_"
Return

Ucini_sifru_nevidljivom:
  If I2 > 0 Then
    Mid(nevidljiva_sifra , I2 , 1) = "*"
    Gosub Disp_sifre
  End If
Return

Brisi_sifru:
  Sifra = "____"
  Nevidljiva_sifra = "____"
  Gosub Disp_sifre
  I2 = 0
Return

Disp_sifre:
  Home U
  Lcd "koda: " ; Nevidljiva_sifra
  Home L
  Lcd Sifra_poruka
Return

Provjeri_sifru:
  If Nacin_rada = 0 Then
    Gosub Provjeri_sifru_rad
  Else
    Gosub Provjeri_sifru_kfg
  End If
Return

Provjeri_sifru_rad:
  Home L
  If Sifra = Sifra_rst And Rst_pin = 0 Then
    Gosub Reset_sifri
    Gosub Ugadjanje_vrata
  Elseif Sifra = Sifra_kfg And Rst_pin = 0 Then
    Lcd "sprememba kode  "
    Rgb_b_on
    Nacin_rada = 1
    Wait 1
    Sifra_poruka = "Vnesi 1. kodo!  "
  Elseif Sifra = Sifra_1 Then
    Rgb_g_on
    If Smjer_1 = 0 Then
      Lcd ">>> 1. vrata >>>"
      Step_n = 1024 : Gosub Step1_pomakni_d
      Smjer_1 = 1
    Else
      Lcd "<<< 1. vrata <<<"
      Step_n = 1024 : Gosub Step1_pomakni_l
      Smjer_1 = 0
    End If
    Gosub Beep
  Elseif Sifra = Sifra_2 Then
    Rgb_g_on
    If Smjer_2 = 0 Then
      Lcd "<<< 2. vrata <<<"
      Step_n = 1024 * 5 : Gosub Step2_pomakni_d
      Smjer_2 = 1
    Else
      Lcd ">>> 2. vrata >>>"
      Step_n = 1024 * 5 : Gosub Step2_pomakni_l
      Smjer_2 = 0
    End If
    Gosub Beep
  Else
    Rgb_r_on
    Lcd "Koda ???        "
    Gosub Beep_3
    Wait 2
  End If
  Home L
  Lcd Spc(16)
  Rgb_g_off
  Rgb_r_off
  Rgb_b_off
Return

Provjeri_sifru_kfg:
  Home L
  If Nacin_rada = 1 Then
    Sifra_1 = Sifra
    Lcd "1. koda vne{002}ena "
    Wait 1
    Sifra_poruka = "Vnesi 2. kodo!  "
    Nacin_rada = 2
  Elseif Nacin_rada = 2 Then
    Sifra_2 = Sifra
    Lcd "2. koda vne{002}ena "
    Sifra_0e = 12
    Sifra_1e = Sifra_1
    Sifra_2e = Sifra_2
    Wait 1
    Home L
    Lcd "Sef pripravljen!"
    Gosub Beep
    Wait 2
    Home L
    Lcd Spc(16)
    Nacin_rada = 0
    Sifra_poruka = "Vpi{002}i kodo!     "
    Gosub Beep
  End If
  Wait 1
Return

Reset_sifri:
  Cls
  Gosub Beep
  Lcd "resetiranje kode"
  Rgb_b_on
  Sifra_1 = "1234"                 'otvori 1. vrata
  Sifra_2 = "5678"                 'otvori 2. vrata
  Sifra_0e = 12
  Sifra_1e = Sifra_1
  Sifra_2e = Sifra_2
  Wait 2
  Home L
  Gosub Beep
  Lcd "koda 1 = " ; Sifra_1 ; "   "
  Wait 3
  Home L
  Gosub Beep
  Lcd "koda 2 = " ; Sifra_2 ; "   "
  Wait 3
  Gosub Beep
Return

Ugadjanje_vrata:
  Cls
  Lcd "nastavitev vrat "
  Wait 2
  Cls
  Gosub Beep
  Lcd "< [1] [OK] [3] >"
  Home L
  Lcd "Odpri 2. vrata! "
  Do
    Gosub Debounce_kbd1
    If Tipka = "1" Then
      Step_n = 5 : Gosub Step2_pomakni_d
    End If
    Gosub Debounce_kbd3
    If Tipka = "3" Then
      Step_n = 5 : Gosub Step2_pomakni_l
    End If
    If Tipka = "O" Then
      Exit Do
    End If
  Loop
  Home L
  Gosub Beep
  Lcd "Odpri 1. vrata! "
  Wait 1
  Do
    Gosub Debounce_kbd1
    If Tipka = "1" Then
      Step_n = 1 : Gosub Step1_pomakni_l
    End If
    Gosub Debounce_kbd3
    If Tipka = "3" Then
      Step_n = 1 : Gosub Step1_pomakni_d
    End If
    If Tipka = "O" Then
      Exit Do
    End If
  Loop
  Rgb_g_on

  Home L
  Gosub Beep
  Lcd "Zapiram vrata!  "
  Step_n = 1025 * 5 : Gosub Step12_pomakni_l
  Rgb_g_off
  Smjer_1 = 0
  Smjer_2 = 0

  Home L
  Gosub Beep
  Lcd "Kon{001}ano!        "
  Wait 3
  Cls
  Gosub Beep
Return

Pcf8574_pisi_citaj:
  Gosub Pcf8574_pisi
  Waitms 1
  Gosub Pcf8574_citaj
  Iz_pcf8574 = Iz_pcf8574 And &B11110000
Return

Pcf8574_pisi:
  I2cstart
  I2cwbyte Pcf8574_adresa
  I2cwbyte Za_pcf8574
  I2cstop
Return

Pcf8574_citaj:
Const Pcf8574_r_adresa = Pcf8574_adresa + 1
  I2cstart
  I2cwbyte Pcf8574_r_adresa
  I2crbyte Iz_pcf8574 , Nack
  I2cstop
Return

Beep_3:
  Gosub Beep
  Waitms 32
Beep_2:
  Gosub Beep
  Waitms 32
Beep:
  For I1 = 0 To 255
    Beep_pin = Not Beep_pin
    Waitus 125
  Next
  Beep_pin = 0
Return

Step1_pomakni_d:
  While Step_n > 0
    Step_i1 = Step_i1 + 2
    Gosub Step1_1_korak
    Waitms Step_delay
    Decr Step_n
  Wend
  Goto Step12_iskljuci

Step1_pomakni_l:
  While Step_n > 0
    Step_i1 = Step_i1 - 2
    Gosub Step1_1_korak
    Waitms Step_delay
    Decr Step_n
  Wend
  Goto Step12_iskljuci

Step2_pomakni_d:
  While Step_n > 0
    Step_i2 = Step_i2 + 2
    Gosub Step2_1_korak
    Waitms Step_delay
    Decr Step_n
  Wend
  Goto Step12_iskljuci

Step2_pomakni_l:
  While Step_n > 0
    Step_i2 = Step_i2 - 2
    Gosub Step2_1_korak
    Waitms Step_delay
    Decr Step_n
  Wend
  Goto Step12_iskljuci

Step12_pomakni_d:
  While Step_n > 0
    Step_i1 = Step_i1 + 2
    Step_i2 = Step_i2 + 2
    Gosub Step1&2_1_korak
    Waitms Step_delay
    Decr Step_n
  Wend
  Goto Step12_iskljuci

Step12_pomakni_l:
  While Step_n > 0
    Step_i1 = Step_i1 - 2
    Step_i2 = Step_i2 - 2
    Gosub Step1&2_1_korak
    Waitms Step_delay
    Decr Step_n
  Wend
  Goto Step12_iskljuci

Step1_1_korak:
  Step_i1 = Step_i1 And &B00000111
  Step_korak = Lookup(step_i1 , Step_tablica)
  Step_data.3 = Step_korak.3
  Step_data.2 = Step_korak.2
  Step_data.1 = Step_korak.1
  Step_data.0 = Step_korak.0
  Goto Step12_1_korak

Step2_1_korak:
  Step_i2 = Step_i2 And &B00000111
  Step_korak = Lookup(step_i2 , Step_tablica)
  Step_data.7 = Step_korak.3
  Step_data.6 = Step_korak.2
  Step_data.5 = Step_korak.1
  Step_data.4 = Step_korak.0
  Goto Step12_1_korak

Step1&2_1_korak:
  Step_i2 = Step_i2 And &B00000111
  Step_korak = Lookup(step_i2 , Step_tablica)
  Step_data.7 = Step_korak.3
  Step_data.6 = Step_korak.2
  Step_data.5 = Step_korak.1
  Step_data.4 = Step_korak.0
  Step_i1 = Step_i1 And &B00000111
  Step_korak = Lookup(step_i1 , Step_tablica)
  Step_data.3 = Step_korak.3
  Step_data.2 = Step_korak.2
  Step_data.1 = Step_korak.1
  Step_data.0 = Step_korak.0
  Goto Step12_1_korak

Step12_iskljuci:
  Step_data = &B00000000

Step12_1_korak:
  Shiftout Hc595out , Hc595clk , Step_data , 1 , 8 , 10
  Hc595ltc = 1
  Waitus 10
  Hc595ltc = 0
Return

Step_tablica:
Data &B1000
Data &B1100
Data &B0100
Data &B0110
Data &B0010
Data &B0011
Data &B0001
Data &B1001